## ros-foxy-rmw-cyclonedds-cpp 0.7.11

=== CMakeLists.txt ===
# Copyright 2018 ADLINK Technology Limited.
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

cmake_minimum_required(VERSION 3.5)

project(rmw_cyclonedds_cpp)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic -Wimplicit-fallthrough)
endif()

find_package(ament_cmake_ros REQUIRED)

find_package(rcutils REQUIRED)
find_package(rcpputils REQUIRED)

#find_package(cyclonedds_cmake_module REQUIRED)
find_package(CycloneDDS QUIET CONFIG)
if(NOT CycloneDDS_FOUND)
  message(WARNING "Could not find Eclipse Cyclone DDS - skipping '${PROJECT_NAME}'")
  ament_package()
  return()
endif()

find_package(rmw REQUIRED)
find_package(rmw_dds_common REQUIRED)
find_package(rosidl_runtime_c REQUIRED)
find_package(rosidl_typesupport_introspection_c REQUIRED)
find_package(rosidl_typesupport_introspection_cpp REQUIRED)

ament_export_dependencies(rcutils)
ament_export_dependencies(rcpputils)
ament_export_dependencies(rmw)
ament_export_dependencies(rosidl_runtime_c)
ament_export_dependencies(rmw_dds_common)
ament_export_dependencies(rosidl_typesupport_introspection_c)
ament_export_dependencies(rosidl_typesupport_introspection_cpp)

add_library(rmw_cyclonedds_cpp
  src/rmw_node.cpp
  src/serdata.cpp
  src/serdes.cpp
  src/u16string.cpp
  src/exception.cpp
  src/demangle.cpp
  src/deserialization_exception.cpp
  src/Serialization.cpp
  src/TypeSupport2.cpp)

target_include_directories(rmw_cyclonedds_cpp PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
)

target_link_libraries(rmw_cyclonedds_cpp
  CycloneDDS::ddsc
)
if(CMAKE_GENERATOR_PLATFORM)
  set(TARGET_ARCH "${CMAKE_GENERATOR_PLATFORM}")
else()
  set(TARGET_ARCH "${CMAKE_SYSTEM_PROCESSOR}")
endif()

if(CMAKE_COMPILER_IS_GNUCXX AND TARGET_ARCH MATCHES "^(riscv|RISCV)64$")
  # using GCC, libatomic is not automatically linked for RISC-V
  target_link_libraries(rmw_cyclonedds_cpp -latomic)
endif()


ament_target_dependencies(rmw_cyclonedds_cpp
  "rcutils"
  "rcpputils"
  "rosidl_typesupport_introspection_c"
  "rosidl_typesupport_introspection_cpp"
  "rmw"
  "rmw_dds_common"
  "rosidl_runtime_c"
)

configure_rmw_library(rmw_cyclonedds_cpp)

target_compile_definitions(${PROJECT_NAME}
  PRIVATE
    RMW_VERSION_MAJOR=${rmw_VERSION_MAJOR}
    RMW_VERSION_MINOR=${rmw_VERSION_MINOR}
    RMW_VERSION_PATCH=${rmw_VERSION_PATCH}
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(${PROJECT_NAME}
  PRIVATE "RMW_CYCLONEDDS_CPP_BUILDING_LIBRARY")

ament_export_include_directories(include)
ament_export_libraries(rmw_cyclonedds_cpp)

register_rmw_implementation(
  "c:rosidl_typesupport_c:rosidl_typesupport_introspection_c"
  "cpp:rosidl_typesupport_cpp:rosidl_typesupport_introspection_cpp")

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()
endif()

ament_package()

install(
  DIRECTORY include/
  DESTINATION include
)

install(
  TARGETS rmw_cyclonedds_cpp
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

include(cmake/get_rmw_cyclonedds_output_filter.cmake)
get_rmw_cyclonedds_output_filter(rmw_cyclonedds_output_patterns)
ament_index_register_resource("rmw_output_patterns" CONTENT "${rmw_cyclonedds_output_patterns}")

=== debian/changelog ===
ros-foxy-rmw-cyclonedds-cpp (0.7.11-1focal) focal; urgency=high

  * Handle allocation errors during message deserialization (#313 <https://github.com/ros2/rmw_cyclonedds/issues/313>) (#419 <https://github.com/ros2/rmw_cyclonedds/issues/419>)
  * Adds topic name to error msg when create_topic fails (#410 <https://github.com/ros2/rmw_cyclonedds/issues/410>) (#422 <https://github.com/ros2/rmw_cyclonedds/issues/422>)_
  * Contributors: Jacob Perron, Michel Hidalgo, Tully Foote, Voldivh

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 20 Sep 2022 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.10-1focal) focal; urgency=high

  * Improve error message when create_topic fails (#405 <https://github.com/ros2/rmw_cyclonedds/issues/405> #408 <https://github.com/ros2/rmw_cyclonedds/issues/408>)
  * Contributors: Shane Loretz, Tully Foote

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 12 Sep 2022 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.9-1focal) focal; urgency=high

  * Fix the history depth for KEEP_ALL (#305 <https://github.com/ros2/rmw_cyclonedds/issues/305>) (#394 <https://github.com/ros2/rmw_cyclonedds/issues/394>)
  * Contributors: Chris Lalancette

 -- Erik Boasson <erik.boasson@adlinktech.com>  Mon, 25 Jul 2022 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.8-1focal) focal; urgency=high

  * Free with the same allocator in rmw_destroy_node (#355 <https://github.com/ros2/rmw_cyclonedds/issues/355>) (#369 <https://github.com/ros2/rmw_cyclonedds/issues/369>)
  * Contributors: Jacob Perron

 -- Erik Boasson <erik.boasson@adlinktech.com>  Fri, 04 Feb 2022 08:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.7-1focal) focal; urgency=high

  * Add -latomic for RISC-V (#332 <https://github.com/ros2/rmw_cyclonedds/issues/332>) (#333 <https://github.com/ros2/rmw_cyclonedds/issues/333>)
  * Contributors: guillaume-pais-siemens

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 31 Aug 2021 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.6-1focal) focal; urgency=high

  * Delete problematic assert in rmw_init() (#265 <https://github.com/ros2/rmw_cyclonedds/issues/265>)
  * Fix context cleanup (#227 <https://github.com/ros2/rmw_cyclonedds/issues/227>)
  * Contributors: Ivan Santiago Paunovic, Michel Hidalgo

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 08 Dec 2020 08:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.5-1focal) focal; urgency=high

  * Fixed cppcheck issue
  * Update service/client construction/destruction API return codes. (#247 <https://github.com/ros2/rmw_cyclonedds/issues/247>)
  * Return RMW_RET_UNSUPPORTED in rmw_get_serialized_message_size (#250 <https://github.com/ros2/rmw_cyclonedds/issues/250>)
  * Update service/client request/response API error returns (#249 <https://github.com/ros2/rmw_cyclonedds/issues/249>)
  * Updated rmw_* return codes (#246 <https://github.com/ros2/rmw_cyclonedds/issues/246>)
  * Update gid API return codes. (#244 <https://github.com/ros2/rmw_cyclonedds/issues/244>)
  * Update graph API return codes. (#243 <https://github.com/ros2/rmw_cyclonedds/issues/243>)
  * Check for message_info on take where appropriate. (#245 <https://github.com/ros2/rmw_cyclonedds/issues/245>)
  * Updated error returns on rmw_take_serialized and with_message_info (#242 <https://github.com/ros2/rmw_cyclonedds/issues/242>)
  * Updated error returns on rmw_take (#241 <https://github.com/ros2/rmw_cyclonedds/issues/241>)
  * Update rmw_publish_serialized_message() error returns (#240 <https://github.com/ros2/rmw_cyclonedds/issues/240>)
  * Update rmw_publish() error returns (#239 <https://github.com/ros2/rmw_cyclonedds/issues/239>)
  * Ensure compliant matched pub/sub count API. (#223 <https://github.com/ros2/rmw_cyclonedds/issues/223>)
  * Change RET_WRONG_IMPLID() to return RMW_RET_INCORRECT_IMPLEMENTATION (#226 <https://github.com/ros2/rmw_cyclonedds/issues/226>)
  * Fix bad conditional in rmw_serialize(). (#217 <https://github.com/ros2/rmw_cyclonedds/issues/217>)
  * Ensure compliant subscription API. (#214 <https://github.com/ros2/rmw_cyclonedds/issues/214>)
  * Ensure compliant publisher API (#210 <https://github.com/ros2/rmw_cyclonedds/issues/210>)
  * Ensure compliant node construction/destruction API. (#206 <https://github.com/ros2/rmw_cyclonedds/issues/206>)
  * Amend rmw_init() implementation: require enclave. (#204 <https://github.com/ros2/rmw_cyclonedds/issues/204>)
  * Ensure compliant init/shutdown API implementations. (#202 <https://github.com/ros2/rmw_cyclonedds/issues/202>)
  * Ensure compliant init options API implementations. (#200 <https://github.com/ros2/rmw_cyclonedds/issues/200>)
  * Finalize context iff shutdown. (#196 <https://github.com/ros2/rmw_cyclonedds/issues/196>)
  * Contributors: Alejandro Hernández Cordero, Jose Tomas Lorente, Michel Hidalgo

 -- Erik Boasson <erik.boasson@adlinktech.com>  Thu, 15 Oct 2020 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.4-1focal) focal; urgency=high

  * rmw_destroy_node must remove node from graph cache (#252 <https://github.com/ros2/rmw_cyclonedds/issues/252>)
  * Contributors: Erik Boasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Wed, 07 Oct 2020 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.3-1focal) focal; urgency=high

  * Fix lost service responses (#183 <https://github.com/ros2/rmw_cyclonedds/issues/183>, #74 <https://github.com/ros2/rmw_cyclonedds/issues/74>) (#187 <https://github.com/ros2/rmw_cyclonedds/issues/187>) (#209 <https://github.com/ros2/rmw_cyclonedds/issues/209>)
  * Contributors: Erik Boasson

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 21 Jul 2020 07:00:00 -0000

ros-foxy-rmw-cyclonedds-cpp (0.7.2-1focal) focal; urgency=high

  * Handle RMW_DEFAULT_DOMAIN_ID (#194 <https://github.com/ros2/rmw_cyclonedds/issues/194>) (#199 <https://github.com/ros2/rmw_cyclonedds/issues/199>)
  * Contributors: Michel Hidalgo

 -- Erik Boasson <erik.boasson@adlinktech.com>  Tue, 07 Jul 2020 07:00:00 -0000



=== debian/control ===
Source: ros-foxy-rmw-cyclonedds-cpp
Section: misc
Priority: optional
Maintainer: Erik Boasson <erik.boasson@adlinktech.com>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake-ros, ros-foxy-ament-lint-auto <!nocheck>, ros-foxy-ament-lint-common <!nocheck>, ros-foxy-cyclonedds, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-typesupport-introspection-c, ros-foxy-rosidl-typesupport-introspection-cpp, ros-foxy-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-foxy-rmw-cyclonedds-cpp
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-cyclonedds, ros-foxy-rcpputils, ros-foxy-rcutils, ros-foxy-rmw, ros-foxy-rmw-dds-common, ros-foxy-rosidl-runtime-c, ros-foxy-rosidl-typesupport-introspection-c, ros-foxy-rosidl-typesupport-introspection-cpp, ros-foxy-ros-workspace
Description: Implement the ROS middleware interface using Eclipse CycloneDDS in C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-rmw-cyclonedds-cpp//opt/ros/foxy/lib/:$(CURDIR)/debian/ros-foxy-rmw-cyclonedds-cpp//opt/ros/foxy/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/:/opt/ros/foxy/lib/:/opt/ros/foxy/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
